/** example1.dart --- Illustrates how to register, dispatch  and listen to an 
 *  event.
 *
 * Copyright (C) 2014  Miguel Guedes
 * 
 * Author: Miguel Guedes <miguel.a.guedes@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see http://www.gnu.org/licenses/.
 *
 * Comments:
 *
 * 
 */


import '../lib/observable.dart';


class Test extends Observable
{
  Test();

  void run() => observer.dispatch("run");
  void runAgain() => observer.dispatch("runAgain", 123);
}


void onRun() => print("Test `run' event received");

void main()
{
  final Test test = new Test()
    ..on.run(onRun)
    ..on.runAgain((arg)
        => print("Test `runAgain' event received with parameter `$arg'"));

  print(test.observer.contains("run"));
  print(test.observer.contains("invalidEvent"));
  print(test.observer.eventContains("run", onRun));
  print(test.observer.eventContains("run", () => print()));
  print(test.observer.eventContains("invalidEvent", () => print()));

  test
    ..run()
    ..runAgain();
}